# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class GenerateAccessTokenResponse(pydantic.BaseModel):
    """
    MoneyKit API access token.
    """

    access_token: str = pydantic.Field(description=("Short-lived access token.\n"))
    token_type: str = pydantic.Field(description=('Always "bearer".\n'))
    expires_in: int = pydantic.Field(description=("How long until `access_token` expires in seconds.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
